Subject: Re: [PATCH] Disable TSO for non standard qdiscs

From: Patrick McHardy <[email-masked]>
Date: Thu, 31 Jan 2008 19:48:03 +0100

Andi Kleen wrote:
> On Thu, Jan 31, 2008 at 07:21:20PM +0100, Patrick McHardy wrote:
>> Andi Kleen wrote:
>>>> Then change TBF to use skb_gso_segment?  Be careful, the fact that
>>> That doesn't help because it wants to interleave packets
>> >from different streams to get everything fair and smooth. The only 
>>> good way to handle that is to split it up and the simplest way to do 
>>> this is to just tell TCP to not do GSO in the first place.
>>
>> Thats not correct, TBF keeps packets strictly ordered unless
> 
> My point was that without TSO different submitters will interleave
> their streams (because they compete about the qdisc submission) 
> and then you end up with a smooth rate over time for all of them.
> 
> If you submit in large chunks only (as TSO does) it will always 
> be more bursty and that works against the TBF goal.
> 
> For a single submitter you would be correct.

The TBF goal is not really fairness among different flows, but
I agree, avoiding TSO in the first place seems to make more sense.